/**
 * EjemplosTema2.java
 *
 * Author: Darren Hodges
 * Date: 16/12/1999
 *
 * Port of the NeHe OpenGL Tutorial (Tema 1, Ejemplo 1: "Modelo Poligonal OpenGL")
 * to Java using the GL4Java interface to OpenGL.
 * Although the title "Setting Up OpenGL In Windows" doesn't really apply
 * to Java because it is a multi-platform language.
 *
 */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.System;
import java.lang.Math.*;


//GL4Java classes
import gl4java.GLContext;
import gl4java.awt.GLAnimCanvas;
import gl4java.applet.SimpleGLAnimApplet1;

public class EjemTema2 extends Applet
{
    //Our rendering canvas
   	//We are using GLAnimCanvas because we want the canvas
   	//to be constantly redrawn
    renderCanvas canvas = null;


	/**
     * void init()
     *
     * Initialise the applet.
     */
	public void init()
	{
        //We will use BorderLayout to layout the applet components
        setLayout(new BorderLayout());
        
        //Create our canvas and add it to the center of the applet
        canvas = new renderCanvas(getSize().width, getSize().height);
	canvas.requestFocus();
        add("Center", canvas);
	}
	
	
	/**
     * void start()
     *
     * Start the applet.
     */
	public void start()
    {
        //Start animating the canvas
        canvas.start();
    }

	
	/**
     * void stop()
     *
     * Stop the applet.
     */
    public void stop()
    {
        //Stop animating the canvas
        canvas.stop();
    }
    /**
     * void destroy()
     *
     * Destroy the applet.
     */
    public void destroy()
    {
        //Stop animating the canvas
        canvas.stop();
        //Destroy the canvas
        canvas.destroy();
    }
    

	public static void main( String args[] ) {
		EjemTema2 applet = 
		         new EjemTema2();

		Frame f = new Frame("EjemTema2");

		GLContext.gljNativeDebug = true;
		GLContext.gljThreadDebug = false;
		GLContext.gljClassDebug = true;

		f.addWindowListener( new WindowAdapter()
				{
					public void windowClosed(WindowEvent e)
					{
						System.exit(0);
					}
					public void windowClosing(WindowEvent e)
					{
						windowClosed(e);
					}
				}
			);

		f.setLayout(new BorderLayout());
		f.add("Center", applet);
		applet.setSize(1024,768);
		applet.init();
		applet.start();
		Dimension ps = applet.getPreferredSize();
		f.setBounds(-500,-400,499,299);
		f.setVisible(true);
		f.setVisible(false);
		f.setVisible(true);
		Insets i = f.getInsets();
		f.setBounds(0,0,
			    ps.width+i.left+i.right, 
		            ps.height+i.top+i.bottom);
		f.setVisible(true);
	}
	

    private class renderCanvas extends GLAnimCanvas
    	implements KeyListener, MouseListener
    {   
        
		boolean	light = true; //Lighting ON/OFF
    	boolean lp = false; //L Pressed?
		char ejemplo='1';
		float angulo=0;
		float azimut=0;
		float inct,incf;
		float PI=3.1416f;
		int mbselect=0;
		float resm=0.1f;
		int backface=1;
		boolean color= false;
		int ngen=3;
	    float [][] generadores = new float[5][4];
		float [][] l_vert_c = new float [8][3];
		int [][] l_polig_c = new int [6][4];
		int n_bezier=4;
		int ndiv_b=30;
		float []difusaA= new float [4]; 
		float []especularA = new float [4];
		float []direccionA = new float [4];
		float []colorA = new float [4]; 
		float []direccion_spot = new float [3]; 
		float []posicion_spot = new float [4]; 

		float angulo_spot=25;
	/*	int nlongitud=15;
		int nlatitud =20;
		float radio=1;*/
		int p_octree=5;
		float l_octree=0.25f;
		float distancia=10f;
		boolean luces=false,luzA=false,luzB=false,luzC=false;
		
	
		float angulo_l=0;
		
		/**
         * renderCanvas(int w, int h)
         *
         * Constructor.
         */
        public renderCanvas(int w, int h)
        {
            super(w, h);
            
            //Registers this canvas to process keyboard events
        	addKeyListener(this);
                addMouseListener(this);    
        }
    
        
        /**
         * void preInit()
         *
         * Called just BEFORE the GL-Context is created.
         */
        public void preInit()
        {
            //We want double buffering
            doubleBuffer = true;
            //But we dont want stereo view
            stereoView = false;
        }
    
    
        /**
         * void init()
         *
         * Called just AFTER the GL-Context is created.
         */
        public void init()
        {
			float ambient[] = { 0.0f, 0.0f, 0.0f, 1.0f };
            float diffuse[] = { 1.0f, 1.0f, 1.0f, 1.0f };
            float specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
            float position[] = { 4.0f, .0f, 0.0f, 1.0f };
            float lmodel_ambient[] = { 0.3f, 0.3f, 0.3f, 1.0f };
            float local_view[] = { 0.0f };
			float two_side[] = { 1.0f };
            //This Will Clear The Background Color To Black
			gl.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);

			//Enables Clearing Of The Depth Buffer
			gl.glClearDepth(1.0);
			//The Type Of Depth Test To Do
			gl.glDepthFunc(GL_LESS);
			//Enables Depth Testing
			gl.glEnable(GL_DEPTH_TEST);

			//Enables Smooth Color Shading
			gl.glShadeModel(GL_SMOOTH);
			//Select The Projection Matrix
			gl.glMatrixMode(GL_PROJECTION);
			//Reset The Projection Matrix
			gl.glLoadIdentity();
			//Calculate The Aspect Ratio Of The Window
			glu.gluPerspective(45.0f, (float)getSize().width / (float)getSize().height, 0.1f, 100.0f);
			//Select The Modelview Matrix
			gl.glMatrixMode(GL_MODELVIEW);
			
			// Luz A DIRECCIONAL.
			
			colorA[0]=0.9f;
			colorA[1]=0.5f;
			colorA[2]=0.5f;
			colorA[3]=1.0f;
			
			direccionA[0]=0.0f;
			direccionA[1]=0.0f;
			direccionA[2]=-1.0f;
			direccionA[3]=0.0f;
			
			
			difusaA[0]=0.0f;
			difusaA[1]=0.8f;
			difusaA[2]=0.0f;
			difusaA[3]=1.0f;
			
			direccion_spot[0]=1;
			direccion_spot[1]=1;
			direccion_spot[2]=0;
			
			posicion_spot[0]=-5;
			posicion_spot[1]=-5;
			posicion_spot[2]=0;
			posicion_spot[3]=1;
			
		
			
			//LUZ 0 DIRECCIONAL
			
			/*gl.glLightfv(GL_LIGHT1,GL_DIFFUSE,difusaA);
			gl.glLightfv(GL_LIGHT1,GL_POSITION,direccionA);
			
			gl.glEnable(GL_LIGHT1);
			gl.glEnable(GL_LIGHTING);*/
			gl.glLightfv(GL_LIGHT1, GL_DIFFUSE, diffuse);
			gl.glLightfv(GL_LIGHT1, GL_SPECULAR, difusaA);
            gl.glLightfv(GL_LIGHT1, GL_POSITION, position);
			
			
			gl.glLightfv(GL_LIGHT2, GL_DIFFUSE, diffuse);
			gl.glLightfv(GL_LIGHT2, GL_SPECULAR, colorA);
            gl.glLightfv(GL_LIGHT2, GL_POSITION, posicion_spot);
            gl.glLightfv(GL_LIGHT2, GL_SPOT_DIRECTION, direccion_spot);
            gl.glLightf(GL_LIGHT2, GL_SPOT_CUTOFF, angulo_spot);
			
		
			gl.glLightfv(GL_LIGHT0, GL_DIFFUSE, difusaA);
            gl.glLightfv(GL_LIGHT0, GL_POSITION, direccionA);
			
            gl.glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
            gl.glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER, local_view);
            gl.glLightModelfv(GL_LIGHT_MODEL_TWO_SIDE,two_side);
            gl.glEnable(GL_LIGHTING);
            gl.glEnable(GL_LIGHT0);
			gl.glEnable(GL_LIGHT1);
            glj.gljCheckGL();
			GUIInit();
			
        }
     public void GUIInit()
	{
		setLayout( null );
		addNotify();
		resize( (insets().left + insets().right + 505), (insets().top + insets().bottom + 470) );

		lightSwitch = new Checkbox( "Light on", null, true );
		//lightSwitch.setBackground( new Color( 255, 255, 255 ));
		lightSwitch.setForeground( new Color( 128, 0, 255 ));
		add( lightSwitch );
		lightSwitch.addNotify();
		lightSwitch.reshape( (insets().left + 19), (insets().top + 25), 69, 19 );

		labelLtIntensity = new Label( "intensity", Label.RIGHT );
		//labelLtIntensity.setBackground( new Color( 255, 255, 255 ));
		labelLtIntensity.setForeground( new Color( 128, 0, 255 ));
		add( labelLtIntensity );
		labelLtIntensity.addNotify();
		labelLtIntensity.reshape( (insets().left + 114), (insets().top + 26), 65, 16 );

		ltIntensity = new TextField( "1" );
		ltIntensity.setEditable( true );
		//ltIntensity.setBackground( new Color( 255, 255, 255 ));
		ltIntensity.setForeground( new Color( 128, 0, 255 ));
		add( ltIntensity );
		ltIntensity.addNotify();
		ltIntensity.reshape( (insets().left + 197), (insets().top + 21), 45, 26 );

	}
   
    
        /**
         * void destroy()
         *
         * Destroy the canvas.
         */
        public void destroy()
        {
            //Destroy the GLContext
            cvsDispose();
        }

	
		public void Esfera_T_Strip(int nlongitud, int nlatitud,float radio)
		{
		float inct;
		float incf;
		int i,j;
		
		float []vertice =new float[3];
		
						
						
		                gl.glEnable(GL_NORMALIZE);
						inct=2*PI/nlongitud;
						incf=PI/nlatitud;
						for(i=nlongitud-1;i>=0;i--)
						{
							gl.glBegin(GL_TRIANGLE_STRIP);
	
							vertice[0]=vertice[1]=0;
							vertice[2]=-radio;
							gl.glNormal3fv(vertice);
							gl.glVertex3fv(vertice);
							
							for(j=1;j<nlatitud-1;j++)
							{
								vertice[0]=(float)(radio*java.lang.Math.cos(i*inct)*java.lang.Math.cos(j*incf-0.5*PI));
								vertice[1]=(float)(radio*java.lang.Math.sin(i*inct)*java.lang.Math.cos(j*incf-0.5*PI));
								vertice[2]=(float)(radio*java.lang.Math.sin(j*incf-0.5*PI));
								gl.glNormal3fv(vertice);
								gl.glVertex3fv(vertice);
								

								vertice[0]=(float)(radio*java.lang.Math.cos((i+1)*inct)*java.lang.Math.cos(j*incf-0.5*PI));
								vertice[1]=(float)(radio*java.lang.Math.sin((i+1)*inct)*java.lang.Math.cos(j*incf-0.5*PI));
								
								
								gl.glNormal3fv(vertice);
								gl.glVertex3fv(vertice);
								
							}	
							vertice[0]=vertice[1]=0;
							vertice[2]=radio;
							gl.glNormal3fv(vertice);
							gl.glVertex3fv(vertice);
							
							
							gl.glEnd();
						}
		
		
		}
		
		/**
		 * void reshape(int width, int height)
		 *
		 * Called after the first paint command.
		 */
        public void reshape(int width, int height)
        {
            //Reset The Current Viewport And Perspective Transformation
			gl.glViewport(0, 0, width, height);

			//Select The Projection Matrix
			gl.glMatrixMode(GL_PROJECTION);
			//Reset The Projection Matrix
			gl.glLoadIdentity();
			//Calculate The Aspect Ratio Of The Window
			glu.gluPerspective(45.0f, (float)getSize().width / (float)getSize().height, 0.1f, 100.0f);
			//Select The Modelview Matrix
			gl.glMatrixMode(GL_MODELVIEW);
        }

        
        /**
         * void display()
         *
         * Draw to the canvas.
         */
        public void display()
        {
            int i,j;
			float no_mat[] = { 0.0f, 0.0f, 0.0f, 1.0f };
            float mat_ambient[] = { 0.7f, 0.0f, 0.0f, 1.0f };
            float mat_ambient_color[] = { 0.8f, 0.0f, 0.2f, 1.0f };
            float mat_diffuse[] = { 0.1f, 0.5f, 0.8f, 1.0f };
            float mat_specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
            float no_shininess[] = { 0.0f };
            float low_shininess[] = { 5.0f };
            float high_shininess[] = { 100.0f };
            float mat_emission[] = {0.3f, 0.2f, 0.2f, 0.0f};
			float position[] = { 4.0f, .0f, 0.0f, 1.0f };
			
			//Ensure GL is initialised correctly
            if (glj.gljMakeCurrent(true) == false)
            	return;
			angulo_l+=0.1;
			
			
			if(ejemplo!=3)
				gl.glDisable(GL_COLOR_MATERIAL);
			position[0]=(float)(4*java.lang.Math.cos(angulo_l));
			position[2]=(float)(4*java.lang.Math.sin(angulo_l));
			
			gl.glLightfv(GL_LIGHT1,GL_POSITION,position);
			
			gl.glLightf(GL_LIGHT2,GL_SPOT_CUTOFF,angulo_spot);
			
            //Clear The Screen And The Depth Buffer
			gl.glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			//Reset The View
			gl.glLoadIdentity();
		    /*if(backface !=0)
			{
				gl.glEnable(GL_CULL_FACE);
				if(backface==1)
					gl.glCullFace(GL_BACK);
				else
					gl.glCullFace(GL_FRONT);
			}
			else*/
			gl.glDisable(GL_CULL_FACE);
            glu.gluLookAt(0,0,-distancia,0,0,-distancia+2,0,1,0);
			gl.glRotatef(angulo,0,1,0);
			gl.glRotatef(azimut,1,0,1);
			
			if(luces)
			{
				if(luzA)
					gl.glEnable(GL_LIGHT1);
				if(luzB)
					gl.glEnable(GL_LIGHT0);
				if(luzC)
					gl.glEnable(GL_LIGHT2);
				gl.glEnable(GL_LIGHTING);
				
				
			}
			else
				gl.glDisable(GL_LIGHTING);
			
			if(!luzA)
				gl.glDisable(GL_LIGHT1);
			if(!luzB)
				gl.glDisable(GL_LIGHT0);
			if(!luzC)
				gl.glDisable(GL_LIGHT2);
			
			
			/*if(luces)
				gl.glDisable(GL_LIGHT0);
			else*/
			    
			
			switch(ejemplo)				
			{	
			case '1':	
						//gl.glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,difusaA);
						gl.glBegin(GL_POLYGON);
							gl.glNormal3f (1,1,1);
							gl.glVertex3f(1.0f,-1.0f,0f);
							gl.glVertex3f(1.0f,1.0f,0f);
							
							gl.glVertex3f(-1.0f,1.0f,0f);
							gl.glVertex3f(-1.0f,-1.0f,0f);
						gl.glEnd();
					break;
			case '2':	
						
						
						//gl.glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,difusaA);
						gl.glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);
						gl.glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_diffuse);
						gl.glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
						gl.glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, low_shininess);
						gl.glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, no_mat);
						//gl.glColor3f(0.5f,0.0f,0.5f);
						Esfera_T_Strip(15,20,2.5f);
										
						break;
			case '3':   gl.glColorMaterial(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE);
						
						gl.glEnable(GL_COLOR_MATERIAL);
						gl.glColor3f(0.9f,0,0.5f);
						Esfera_T_Strip(40,20,1.5f);
						
						
						break;
			
						
			}
            //Swap buffers
            glj.gljSwap();
            glj.gljFree();
        }
        
        
        /**
     	 * void keyTyped(KeyEvent e)
     	 *
     	 * Invoked when a key has been typed. This event occurs when a key press is followed by a key release. 
     	 */
		
    	public void keyTyped(KeyEvent e)
		{
			//We are not handling any keyboard events yet
	
		}


 		/**
 	 	 * void keyPressed(KeyEvent e)
 	 	 *
 	 	 * Invoked when a key has been pressed.
 	 	 */
 		public void keyPressed(KeyEvent e)
		{
			//We are not handling any keyboard events yet
			if (glj.gljMakeCurrent(true) == false)
			return;

			switch(e.getKeyCode())
			{
				//Switch ON/OFF light when L is pressed
				case KeyEvent.VK_W:
				{
					if(!lp)
					{
						lp = true;
						//Toggle light
						light = !light;
				
						if(!light)
							gl.glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
						else
							gl.glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
					
					}
					else
						lp=false;
					break;
				}
				case KeyEvent.VK_L:
				{
					luces=!luces;
					break;
				}
				case KeyEvent.VK_A:
				{
					luzA=!luzA;
					break;
				}
				case KeyEvent.VK_S:
				{
				
					break;
				}
				case KeyEvent.VK_D:
				{
				
					break;
				}
				case KeyEvent.VK_F:
				{
					
					break;
				}
				case KeyEvent.VK_G:
				{
					gl.glShadeModel(GL_SMOOTH);
					break;
				}
				case KeyEvent.VK_1:
				{
					ejemplo='1';
					break;
				}
				case KeyEvent.VK_V:
				{
					
					break;
				}
				case KeyEvent.VK_B:
				{
					luzB=!luzB;
					break;
				}
				case KeyEvent.VK_C:
				{
					luzC=!luzC;
					break;
				}
				case KeyEvent.VK_O:
				{
					luzC=!luzC;
					break;
				}
				case KeyEvent.VK_P:
				{
					gl.glShadeModel(GL_FLAT);
					break;
				}
				case KeyEvent.VK_R:
				{
					angulo_spot++;
					break;
				}
				case KeyEvent.VK_T:
				{
					angulo_spot--;
					break;
				}
				case KeyEvent.VK_2:
				{
					ejemplo='2';
					break;
				}
				case KeyEvent.VK_3:
				{
					ejemplo='3';
					break;
				}
				case KeyEvent.VK_4:
				{
					ejemplo='4';
					break;
				}
				case KeyEvent.VK_5:
				{
					ejemplo='5';
					break;
				}
				case KeyEvent.VK_6:
				{
					ejemplo='6';
					break;
				}
				case KeyEvent.VK_7:
				{
					ejemplo='7';
					break;
				}
				case KeyEvent.VK_8:
				{
					ejemplo='8';
					break;
				}
				case KeyEvent.VK_9:
				{
					ejemplo='9';
					break;
				}
				case KeyEvent.VK_X:
				{
					
					distancia+=0.5;
					break;
				}
				
				case KeyEvent.VK_Z:
				{
					distancia-=0.5;
					break;
				}
				case KeyEvent.VK_LEFT:
				{
		
					
						angulo+=2;
					break;
				}
				case KeyEvent.VK_RIGHT:
				{
				 
			
					angulo-=2;
					break;
				}
				case KeyEvent.VK_UP:
				{
	
						azimut+=2;
					break;
				}
				case KeyEvent.VK_DOWN:
				{
	
					azimut-=2;
					break;
				}
				 
			}
		}


		/**
	 	 * void keyReleased(KeyEvent e)
	 	 *
	 	* Invoked when a key has been released. 
	 	 */
		public void keyReleased(KeyEvent e)
		{
			//We are not handling any keyboard events yet
		}

        // Methods required for the implementation of MouseListener
        public void mouseEntered( MouseEvent evt )
        {
            Component comp = evt.getComponent();
	    if( comp.equals(this ) )
	    {
		requestFocus();
	    }
        }

        public void mouseExited( MouseEvent evt )
        { }
        public void mousePressed( MouseEvent evt )
        {
			
		}
        public void mouseReleased( MouseEvent evt )                                     
		{
		
		}
        public void mouseClicked( MouseEvent evt )
        { 
            Component comp = evt.getComponent();
			if(mbselect!=0)
					{
						generadores[mbselect-1][3]+=0.05;
						
					}
						
	    if( comp.equals(this ) )
	    {
			requestFocus();
	    }
	}

    }
}
